# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/sun-jaf/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define jafver  1.1.1
%define jar_name activation
%global fullversion 1.1.1
%global namedversion %{fullversion}-redhat-1

Name:           glassfish-jaf
Version:        1.1.1
Release:        11.redhat_1%{?dist}
Epoch:          0
Summary:        Glassfish - JavaBeans Activation Framework
License:        CDDL
Group:          Development/Java
URL:            http://glassfish.dev.java.net/
# svn export https://svn.java.net/svn/glassfish~svn/tags/api-20110628/activation/ glassfish-jaf-1.1.1
# Exported revision 52138.
# tar czf glassfish-jaf-1.1.1.tar.gz glassfish-jaf-1.1.1/
Source0:        %{name}-%{version}.tar.gz
#cvs -d :pserver:guest@cvs.dev.java.net:/cvs checkout glassfish/activation
Source1:        %{name}-1.1.0-LICENCE.tar.gz
#cvs -d :pserver:guest@cvs.dev.java.net:/cvs checkout glassfish/bootstrap ... this tar is a tar of the legal folder under glassfish/bootstrap

Patch0:         glassfish-jaf-1.1.1-vman-pom.patch

BuildRequires:  ant >= 0:1.6.5
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.4.2
BuildRequires:  maven2
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-site
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven2-plugin-surefire
BuildRequires:	maven2-plugin-release
BuildRequires:	jboss-parent

Provides:       jaf = 0:%{jafver}
Provides:       jaf_api = 0:%{jafver}
Provides:       jaf_1_1_api
Provides:        activation
# Needed for backwards compatibility
Provides:       jaf = 1.1

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JavaBeans Activation Framework. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Provides:       jaf-javadoc = 0:%{jafver}

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%setup -q -n %{name}-%{version} -T -D -a 1

%patch0 -p1

# fix  version
#sed -i 's|<version>1.1-rev-1</version>|<version>1.1.1</version>|' pom.xml

%build

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mvn-jpp \
        -e \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        -DaltDeploymentRepository=oss-releases::default::file:maven2-brew \
        install javadoc:javadoc deploy:deploy
#        -Dversion=%{version} \
%install
rm -rf $RPM_BUILD_ROOT

ls -lR

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 0644 target/%{jar_name}-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{namedversion}.jar
%add_to_maven_depmap javax.activation activation %{namedversion} JPP %{name}

#FIXME: it's better to install these two pom in a separate package
#%add_to_maven_depmap org.glassfish pom 2 JPP glassfish-pom
#%add_to_maven_depmap org.glassfish.api api 1 JPP glassfish-api

pushd $RPM_BUILD_ROOT%{_javadir}
ln -sf %{name}-%{namedversion}.jar %{name}.jar
popd

pushd $RPM_BUILD_ROOT%{_javadir}
ln -s %{name}-%{namedversion}.jar jaf-%{jafver}.jar
ln -s %{name}-%{namedversion}.jar jaf_api.jar
ln -s %{name}-%{namedversion}.jar jaf_1_1_1_api.jar
ln -s %{name}-%{namedversion}.jar jaf.jar
ln -s %{name}-%{namedversion}.jar activation.jar
popd

#touch $RPM_BUILD_ROOT%{_javadir}/activation.jar
#touch $RPM_BUILD_ROOT%{_javadir}/jaf.jar
#touch $RPM_BUILD_ROOT%{_javadir}/jaf_api.jar
#touch $RPM_BUILD_ROOT%{_javadir}/jaf_1_1_api.jar

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%{_sbindir}/update-alternatives --install %{_javadir}/jaf.jar jaf %{_javadir}/%{name}.jar 10100
%{_sbindir}/update-alternatives --install %{_javadir}/activation.jar activation %{_javadir}/%{name}.jar 10100
%{_sbindir}/update-alternatives --install %{_javadir}/jaf_api.jar jaf_api %{_javadir}/%{name}.jar 10100
%{_sbindir}/update-alternatives --install %{_javadir}/jaf_1_1_api.jar jaf_1_1_api %{_javadir}/%{name}.jar 10100

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove jaf %{_javadir}/%{name}.jar
    %{_sbindir}/update-alternatives --remove jaf_api %{_javadir}/%{name}.jar
    %{_sbindir}/update-alternatives --remove activation %{_javadir}/%{name}.jar
    %{_sbindir}/update-alternatives --remove jaf_1_1_api %{_javadir}/%{name}.jar
fi

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc legal/LICENSE.txt
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
#%{_javadir}/jaf-%{jafver}.jar
%ghost %{_javadir}*/jaf.jar
%ghost %{_javadir}*/jaf-1.1.1.jar
%ghost %{_javadir}*/activation.jar
%ghost %{_javadir}*/jaf_api.jar
%ghost %{_javadir}*/jaf_1_1_1_api.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed May 09 2012 Yong Yang <yyang@redhat.com> 0:1.1.1-11_redhat_1
- Fix vman pom
- Remove unused Sources

* Wed Apr 25 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.1.1-10.redhat_1
- Fix provides

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.1.1-9_redhat_1.1
- Rebuild using cache signing

* Tue Jan 17 2012 Yong Yang <yyang@redhat.com> 0:1.1.1-9_redhat_1
- Use correct source0 which pom has 1.1.1 version instead of 1.1-rev-1

* Mon Jan 16 2012 Yong Yang <yyang@redhat.com> 0:1.1.1-8_redhat_1
- Fix issue that pom was deployed to dir without -redhat-1 tail

* Mon Jan 16 2012 Yong Yang <yyang@redhat.com> 0:1.1.1-7_redhat_1
- Remove glassfish-api parent from pom

* Tue Sep 20 2011 Yong Yang <yyang@redhat.com> 0:1.1.1-6_redhat_1
- Fix pom location of repolib

* Mon Sep 19 2011 Yong Yang <yyang@redhat.com> 0:1.1.1-5_redhat_1
- Fix pom

* Fri Sep 16 2011 Yong Yang <yyang@redhat.com> 0:1.1.1-4_redhat_1
- Build for Werewolf

* Fri Jul 08 2011 Yong Yang <yyang@redhat.com> 0:1.1.1-3
- Install glassfish parent poms

* Wed Jul 06 2011 Yong Yang <yyang@redhat.com> 0:1.1.1-2
- Specify -Dversion to mvn-jpp

* Wed Jul 06 2011 Yong Yang <yyang@redhat.com> 0:1.1.1-1
- Upgrade to 1.1.1

* Thu Jan 20 2011 Fernando Nasser <fnasser@redhat.com> 0:1.1.0-8
- Fix maven repo path and filename version to match pom

* Tue Nov 30 2010 Hui Wang <huwang@redhat.com> - 0:1.1.0-7
- Add upload.sh and content of maven2-brew to repolib
- Fix %%files for signed jars

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.1.0-6.2.1
- rebuilt

* Tue Apr 20 2010 Luiz Barreiros <gbarreir@redhat.com> 0:1.1.0-6-2
- Rebuild

* Thu Jan 14 2010 Permaine Cheung <pcheung@redhat.com> 0:1.1.0-6.1
- Merge with RHEL-4-EP-5 branch

* Thu Jul 31 2008 Fernando Nasser <fnasser@redhat.com> 0:1.1.0-0jpp.ep1.12.1
- Adapt for RHEL-5

* Mon Jun 23 2008 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.12
- Change to glassfish/jaf from sun-jaf 

* Mon Apr 07 2008 Fernando Nasser <fnasser@redhat.com> 0:1.1.0-0jpp.ep1.11.1
- Rebuild
- Leave out no-ghosting hack from RHEL-4

* Mon Mar 31 2008 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.11
- Removed the post/postun javadoc sections (Taken care of by install and files javadoc) 

* Fri Feb 15 2008 Fernando Nasser <fnasser@redhat.com> 0:1.1.0-0jpp.ep1.10
- Do not ghost (which would be the right thing) because of a bug in the
  classpathx-jaf package and some RPM bug with ghosts (already fixed in RHEL-5)

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.1.0-0jpp.ep1.9
- Revert to sun-jaf name due to "buildmagic" 

* Fri Nov 23 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.8
- Build with debug info

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.1.0-0jpp.ep1.7
- Parametrize component-info contents
- Install real JAR into repolibdir

* Thu Nov 22 2007 Fernando Nasser <fnasser@redhat.com> 0:1.1.0-0jpp.ep1.6
- Fix installed name of component-info.xml

* Thu Nov 22 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.5
- Adding component-info.xml
- Changed the repodir to glassfish/jaf 
- Insert alternatives for activation

* Tue Nov 20 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.4
- Adding in the pom stuff 

* Thu Nov 15 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.3
- Rebuild with 1.5 

* Thu Nov 15 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.2
- Add jaf jaf_api jaf_1_1_api Provides and alternatives

* Tue Nov 13 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.1.0-0jpp.ep1.1
- First release.
